#define TRUE    1
#define FALSE   0
#define ERR     (-1)

#define UCHAR   unsigned char
#define SHORT   short int
#define	UNSIG	unsigned int

#define	OFFSET(p,n)	*((unsigned int *)(&(p)))=n
#define	SEGSET(p,n)	*((unsigned int *)(&(p))+1)=n

#define	HIGH(p)		((unsigned char far *)(&(p))+1)
#define	LOW(p)		((unsigned char far *)(&(p)))

#define	U_AX	(reg->r_ax)
#define U_AH    *((unsigned char far *)(&(reg->r_ax))+1)
#define	U_AL	*((unsigned char far *)(&(reg->r_ax)))

#define	U_BX	(reg->r_bx)
#define	U_BH	*((unsigned char far *)(&(reg->r_bx))+1)
#define	U_BL	*((unsigned char far *)(&(reg->r_bx)))

#define	U_CX	(reg->r_cx)
#define	U_CH	*((unsigned char far *)(&(reg->r_cx))+1)
#define	U_CL	*((unsigned char far *)(&(reg->r_cx)))

#define	U_DX	(reg->r_dx)
#define	U_DH	*((unsigned char far *)(&(reg->r_dx))+1)
#define	U_DL	*((unsigned char far *)(&(reg->r_dx)))

#define	U_DI	(reg->r_di)
#define	U_SI	(reg->r_si)

#define	U_DS	(reg->r_ds)
#define	U_ES	(reg->r_es)

#define	U_CF	(reg->r_cf)

#define	CVRAM	0xC800
#define	KVRAM	0xCA00

#define	SCR_X	80
#define MAX_X   80
#ifdef	LINE40
  #define MAX_Y   40
#else
  #define MAX_Y   25
#endif

#define DMYKAN  0xFE
#define CRCHR   0x1F
#define TABCHR  0x09
#define	NULCHR	0x20
#define TAB     8
#define CONTRL  FALSE
#define DEFCOL  COLOR

SHORT    CUR_X=0,CUR_Y=0;
SHORT    CUR_TYPE=0x30;
SHORT    CUR_OFF2=14,CUR_SIZE2=2;
UCHAR    CUR_DSP_FLG=0;
UCHAR    Con_mode=0xCE;
SHORT    SCR_Y=MAX_Y;
SHORT    COLOR=7,BAKCOL=0;
UCHAR    Act_Dsp=FALSE;

struct _REGSET {
    SHORT	r_es;
    SHORT	r_ds;
    SHORT	r_di;
    SHORT	r_si;
    SHORT	r_bp;
    SHORT	r_sp;
    SHORT	r_bx;
    SHORT	r_dx;
    SHORT	r_cx;
    SHORT	r_ax;
    SHORT	r_ip;
    SHORT	r_cs;
    SHORT	r_cf;
};

/**************************************************************

	CONSOL BIOS (int 91h) 

***************************************************************/
void	VDB_00(reg)	/*  */
register struct _REGSET far *reg;
{
    SCR_Y = MAX_Y - 1;
    CUR_DSP_FLG = 0;
    Con_mode = 0xCE;
    CUR_X = CUR_Y = 0;
    COLOR = 7;
    colset(0,COLOR,(MAX_X * 2) * MAX_Y);
}
void	VDB_01(reg)
register struct _REGSET far *reg;
{
}	/* ʂ̕\ */

void	VDB_02(reg)	/* Sʏ */
register struct _REGSET far *reg;
{
    colset(0,DEFCOL,(MAX_X * 2) * MAX_Y);
    CUR_X = CUR_Y = 0;
}
void 	VDB_03(reg)	/* \ʃTCY̐ݒ */
register struct _REGSET far *reg;
{
    if ( (SCR_Y = U_DH) > MAX_Y )
	SCR_Y = MAX_Y;
    if ( (Con_mode & 0x40) != 0 )
	SCR_Y--;
}
void 	VDB_04(reg)	/* \ʃTCY̓ǂݎ */
register struct _REGSET far *reg;
{
    U_DL = SCR_X;
    U_DH = SCR_Y;
}
void	VDB_05(reg)	/* \ʃTCYp|g̓ǂݎ */
register struct _REGSET far *reg;
{
    char far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);

    if ( *(p++) < 4 )
	return;
    *(p++) = 1;
    *(p++) = 80;
    *(p++) = 25;
}
void 	VDB_06(reg)	/* Agr[g@\͈͂̓ǂݎ */
register struct _REGSET far *reg;
{
    char far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);
    *(p++) = 0x03;	/* ʉ\ */
    *(p++) = 0x38;	/* - & @*/
    *(p++) = 0x07;	/* őF */
    *p = 0;
}
void	VDB_07(reg)	/* tHgp^|̎o */
register struct _REGSET far *reg;
{
    int     i;
    char far *fp;
    char far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);

    if ( U_BH == 0 ) {	/* ANK 8x8 or 8x16 */
	if ( U_DH != 8 )
	    goto ERROR;
	else if ( U_DL == 8 ) {
	    SEGSET(fp,0xCA00);
	    OFFSET(fp,U_BL * 8);
	    outp(0xFF99,1);
	    for ( i = 0 ; i < 8 ; i++ )
		*(p++) = *(fp++);
	    outp(0xFF99,0);
	    return;
	} else if ( U_DL == 16 ) {
	    SEGSET(fp,0xCB00);
	    OFFSET(fp,U_BL * 16);
	    outp(0xFF99,1);
	    for ( i = 0 ; i < 16 ; i++ )
		*(p++) = *(fp++);
	    outp(0xFF99,0);
	    return;
	} else
	    goto ERROR;
    } else if ( U_DX == 0x1010 ) {	/* Kanji 16x16 */
    	outp(0xFF94,U_BL);
    	outp(0xFF95,U_BH);
	for ( i = 0 ; i < 16 ; i++ ) {
	    *(p++) = inp(0xFF96);
	    *(p++) = inp(0xFF97);
	}
	return;
    }
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void	VDB_08(reg)
register struct _REGSET far *reg;
{}	/* Op^|̓o^ */

void	VDB_09(reg)	/* J|\`̐ݒ */
register struct _REGSET far *reg;
{
    switch(U_AL & 0x0F) {
	case 0: CUR_OFF2 = 14; CUR_SIZE2 = 2; break;
	case 1: CUR_OFF2 = 0;  CUR_SIZE2 = 16; break;
	case 15: CUR_OFF2 = U_DH;
		 CUR_SIZE2 = U_DL - CUR_OFF2;
		if ( CUR_OFF2 < 0 || CUR_OFF2 > 15 )
		    CUR_OFF2 = 15;
		if ( CUR_SIZE2 < 0 || (CUR_SIZE2 + CUR_OFF2) > 16 )
		    CUR_SIZE2 = 16 - CUR_OFF2;
		break;
    }
    if ( (U_AL & 0x60) == 0x20 )
	CUR_DSP_FLG = 1;
    else
	CUR_DSP_FLG = 0;
    CUR_TYPE = U_AL;
}
void	VDB_0A(reg)	/* J|\`̓ǂݎ */
register struct _REGSET far *reg;
{
    U_AL = CUR_TYPE;
    U_DH = CUR_OFF2;
    U_DL = CUR_OFF2 + CUR_SIZE2;
}
void	VDB_0B(reg)	/* J|\\Ԃ̐ݒ */ 
register struct _REGSET far *reg;
{
    CUR_DSP_FLG = U_AL;
}
void	VDB_0C(reg)	/* J|\\Ԃ̓ǂݎ */
register struct _REGSET far *reg;
{
    U_AL = CUR_DSP_FLG;
}
void    VDB_0D(reg)	/* J[\ʒu̎w */
register struct _REGSET far *reg;
{
    CUR_X = U_DL - 1;
    CUR_Y = U_DH - 1;
    if ( CUR_X < 0 ) CUR_X = 0;
    if ( CUR_X >= SCR_X ) CUR_X = SCR_X - 1;
    if ( CUR_Y < 0 ) CUR_Y = 0;
    if ( CUR_Y >= MAX_Y ) CUR_Y = MAX_Y - 1;
}
void 	VDB_0E(reg)	/* J[\ʒu̓ǂݎ */
register struct _REGSET far *reg;
{
    U_DL = CUR_X + 1;
    U_DH = CUR_Y + 1;
}
void	VDB_0F(reg)	/* Agr[g̐ݒ */
register struct _REGSET far *reg;
{
    int    at,x,y;
    char   far *p;
    UCHAR  far *vp;

    x = U_DL - 1;
    y = U_DH - 1;
    SEGSET(vp,CVRAM);
    OFFSET(vp,(x * 2 + (MAX_X * 2) * y + 1));

    SEGSET(p,U_DS);
    OFFSET(p,(U_DI + 1));
    at = *vp & 0xC0;
    *vp = at | (*p & 0x38) | (*(p+1) & 0x07);
}
void	VDB_10(reg)	/* Agr[g̓ǂݎ */
register struct _REGSET far *reg;
{
    int    at,x,y;
    char   far *p;
    UCHAR  far *vp;

    x = U_DL - 1;
    y = U_DH - 1;
    SEGSET(vp,CVRAM);
    OFFSET(vp,(x * 2 + (MAX_X * 2) * y + 1));
    SEGSET(p,U_DS);
    OFFSET(p,U_DI);
    if ( (*vp & 0x40) != 0 )
	*p = 0x01;
    else if ( x > 0 && (*(vp-2) & 0x40) != 0 ) {
	*p = 0x03;
	vp -= 2;
    } else
	*p = 0x00;

    *(++p) = *vp & 0x38;
    *(++p) = *vp & 0x07;
}
void	VDB_11(reg)	/* ftHgAgr|g̐ݒ */
register struct _REGSET far *reg;
{
    char far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);
    DEFCOL = (*(++p) & 0x38);
    DEFCOL |= (*(++p) & 0x07);
}
void	VDB_12(reg)	/* ftHgAgr|g̓ǂݎ */
register struct _REGSET far *reg;
{
    char far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);
    *(++p) = DEFCOL & 0x38;
    *(++p) = DEFCOL & 0x07;
}
void	VDB_13(reg)	/* ݒ */
register struct _REGSET far *reg;
{
    int    ch,x,y;
    UCHAR  far *vp;

    x = U_DL - 1;
    y = U_DH - 1;
    ch = U_BL;
    SEGSET(vp,CVRAM);
    OFFSET(vp,(x * 2 + (MAX_X * 2) * y));
    *(vp++) = ch;
    if ( U_AL != 1 )
	*vp = DEFCOL;
    else
	*vp &= 0x3F;
    if ( U_BH == 0x01 )
	*vp |= 0x40;
    else if ( U_BH == 0x03 ) {
	ch |= (*(vp-3) << 8);
	*(vp-1) = *(vp-3) = DMYKAN;
        SEGSET(vp,KVRAM);
	*(vp-3) = ch >> 8;
	*(vp-2) = ch;
    }
}
void	VDB_14(reg)	/* ǂݎ */
register struct _REGSET far *reg;
{
    int    at,x,y;
    UCHAR  far *vp;

    x = U_DL - 1;
    y = U_DH - 1;
    SEGSET(vp,CVRAM);
    OFFSET(vp,(x * 2 + (MAX_X * 2) * y));
    if ( (*(vp+1) & 0x40) != 0 ) {
	U_BH = 0x01;
        SEGSET(vp,KVRAM);
        U_BL = *vp;
    } else if ( x > 0 && (*(vp-1) & 0x40) != 0 ) {
	U_BH = 0x03;
        SEGSET(vp,KVRAM);
        U_BL = *(vp-1);
    } else {
	U_BH = 0x00;
        U_BL = *vp;
    }
}
void	VDB_15(reg)	/* `ݒ */
register struct _REGSET far *reg;
{
    int     cx,ch;
    int     x1,y1,x2,y2;
    int     x,y,sx,sy;
    UNSIG far *p;
    UCHAR far *cp;
    UCHAR far *ap;
    UCHAR far *sp;
    UCHAR far *vp;

    if ( (x1 = U_DL - 1) >= MAX_X || x1 < 0)
	goto ERROR;
    if ( (y1 = U_DH - 1) >= SCR_Y || y1 < 0 )
	goto ERROR;
    if ( (x2 = U_BL) > MAX_X )
	goto ERROR;
    if ( (y2 = U_BH) > SCR_Y )
	goto ERROR;
    sx = x2 - x1; sy = y2 - y1;
    if ( sx <= 0 || sy <= 0 )
	goto ERROR;
    SEGSET(sp,CVRAM);
    OFFSET(sp,(x1 * 2 + (MAX_X * 2) * y1));

    OFFSET(p,U_DI);
    SEGSET(p,U_DS);

    OFFSET(cp,*(p++));
    SEGSET(cp,*(p++));

    OFFSET(ap,*(p++));
    SEGSET(ap,*(p++));

    for ( y = 0 ; y < sy ; y++ ) {
	for ( x = 0,vp = sp ; x < sx ; x++ ) {
	    *(vp++) = *(cp++);
	    if ( *(ap++) == 0x03 ) {
		*(vp-2) |= 0x40;
		ch = *(vp-3) << 8 | *(vp-1);
		SEGSET(vp,KVRAM);
		*(vp-3) = ch >> 8;
		*(vp-2) = ch;
		SEGSET(vp,CVRAM);
	    } else
		*vp &= 0x3F;
	    if ( U_AL == 1 ) {
		*vp = *(ap++) & 0x38;
		*vp |= *(ap++) & 0x07; ap++;
	    }
	    vp++;
	}
	sp += (MAX_X * 2);
    }
    return;
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void    VDB_16(reg)        /* `ǂݎ */
register struct _REGSET far *reg;
{
    int     i;
    int     x1,y1,x2,y2;
    int     x,y,sx,sy;
    UNSIG far *p;
    UCHAR far *cp;
    UCHAR far *ap;
    UCHAR far *sp;
    UCHAR far *vp;

    if ( (x1 = U_DL-1) >= MAX_X || x1 < 0)
	goto ERROR;
    if ( (y1 = U_DH-1) >= SCR_Y || y1 < 0 )
	goto ERROR;
    if ( (x2 = U_BL) > MAX_X )
	goto ERROR;
    if ( (y2 = U_BH) > SCR_Y )
	goto ERROR;
    sx = x2 - x1; sy = y2 - y1;
    if ( sx <= 0 || sy <= 0 )
	goto ERROR;
    SEGSET(sp,CVRAM);
    OFFSET(sp,(x1 * 2 + (MAX_X * 2) * y1));

    OFFSET(p,U_DI);
    SEGSET(p,U_DS);

    OFFSET(cp,*(p++));
    SEGSET(cp,*(p++));

    OFFSET(ap,*(p++));
    SEGSET(ap,*(p++));

    for ( y = 0 ; y < sy ; y++ ) {
	for ( x = 0,vp = sp ; x < sx ; x++ ) {
	    *(cp++) = *(vp++);
	    if ( (*vp & 0x40) != 0 ) {
		*(ap++) = 0x01;
		SEGSET(vp,KVRAM);
		*(cp-1) = *(vp-1);
		SEGSET(vp,CVRAM);
	    } else if ( x > 0 && (*(vp-2) & 0x40) != 0 ) {
		*(ap++) = 0x03;
		SEGSET(vp,KVRAM);
		*(cp-1) = *(vp-2);
		SEGSET(vp,CVRAM);
	    } else
		*(ap++) = 0x00;
	    if ( U_AL == 1 ) {
		*(ap++) = *vp & 0x38;
		*(ap++) = *vp & 0x07; ap++;
	    }
	    vp++;
	}
	sp += (MAX_X * 2);
    }
    return;
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void	VDB_17(reg)	/* `敡 */
register struct _REGSET far *reg;
{
    int     i;
    int     x1,y1,x2,y2,x3,y3;
    int     sx,sy;
    UNSIG   sp;
    UNSIG   dp;

    if ( (x1 = U_DL - 1) >= MAX_X || x1 < 0 )
	goto ERROR;
    if ( (y1 = U_DH - 1) >= SCR_Y || y1 < 0 )
	goto ERROR;
    if ( (x2 = U_BL) > MAX_X )
	goto ERROR;
    if ( (y2 = U_BH) > SCR_Y )
	goto ERROR;
    if ( (x3 = U_CL - 1) >= MAX_X || x3 < 0 )
	goto ERROR;
    if ( (y3 = U_CH - 1) >= SCR_Y || y3 < 0 )
	goto ERROR;
    sx = x2 - x1; sy = y2 - y1;
    if ( sx <= 0 || sy <= 0 )
	goto ERROR;
    if ( (x3 + sx) > MAX_X || (y3 + sy) > SCR_Y )
	goto ERROR;

    if ( sp < dp ) {
	sp = (x2 - 1) * 2 + (MAX_X * 2) * (y2 - 1);
	dp = (x3 + sx - 1) * 2 + (MAX_X * 2) * (y3 + sy - 1);
	for ( i = 0 ; i < sy ; i++ ) {
	    vramrcpy(dp,sp,sx * 2);
	    sp -= (MAX_X * 2);
	    dp -= (MAX_X * 2);
	}
    } else {
	sp = x1 * 2 + (MAX_X * 2) * y1;
	dp = x3 * 2 + (MAX_X * 2) * y3;
	for ( i = 0 ; i < sy ; i++ ) {
	    vramcpy(dp,sp,sx * 2);
	    sp += (MAX_X * 2);
	    dp += (MAX_X * 2);
	}
    }
    return;
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void	VDB_18(reg)	/* ` */
register struct _REGSET far *reg;
{
    int     i;
    int     x1,y1,x2,y2;
    int     sx,sy;
    UNSIG   sp;

    if ( (x1 = U_DL - 1) >= MAX_X || x1 < 0 )
	goto ERROR;
    if ( (y1 = U_DH - 1) >= SCR_Y || y1 < 0 )
	goto ERROR;
    if ( (x2 = U_BL) > MAX_X )
	goto ERROR;
    if ( (y2 = U_BH) > SCR_Y )
	goto ERROR;
    sx = x2 - x1; sy = y2 - y1;
    if ( sx <= 0 || sy <= 0 )
	goto ERROR;
    sp = (x1 * 2 + (MAX_X * 2) * y1);

    for ( i = 0 ; i < sy ; i++ ) {
	colset(sp,DEFCOL,sx * 2);
	sp += (MAX_X * 2);
    }
    return;
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void	VDB_19(reg)	/* SʃXN| */ 
register struct _REGSET far *reg;
{
    int     cx,i;
    UNSIG   vp;

    if ( (cx = U_CX) == 0 || cx > SCR_Y )
	cx = SCR_Y;
    for ( ; cx > 0 ; cx-- ) {
	switch(U_AL) {
	    case 1:	/*  */
		i = (MAX_X * 2) * (SCR_Y - 1);
		vramrcpy(i + (MAX_X * 2 - 2),i - 2,i);
		colset(0,DEFCOL,(MAX_X * 2));
		break;
	    case 2:	/* E */
		i = (MAX_X * 2) * SCR_Y - 2;
		vramrcpy(i,i - 2,i);
		vp = 0;
		for ( i = 0 ; i < SCR_Y ; i++ ) {
		    colset(vp,DEFCOL,2);
		    vp += (MAX_X * 2);
		}
		break;
	    case 3:	/*  */
		vramcpy(0,2,(MAX_X * 2) * SCR_Y - 2);
		vp = (MAX_X * 2) - 2;
		for ( i = 0 ; i < SCR_Y ; i++ ) {
		    colset(vp,DEFCOL,2);
		    vp += (MAX_X * 2);
		}
		break;
            default: 	/* case 0  */
		vramcpy(0,(MAX_X * 2),(MAX_X * 2) * (SCR_Y - 1));
		colset((MAX_X * 2) * (SCR_Y - 1),DEFCOL,(MAX_X * 2));
		break;
	}
    }
}
void	VDB_1A(reg)	/* XN| */
register struct _REGSET far *reg;
{
    int     cx,i;
    int     x1,y1,x2,y2;
    int     sx,sy;
    UNSIG   sp;
    UNSIG   vp;

    if ( (x1 = U_DL - 1) >= MAX_X || x1 < 0 )
	goto ERROR;
    if ( (y1 = U_DH - 1) >= SCR_Y || y1 < 0 )
	goto ERROR;
    if ( (x2 = U_BL) > MAX_X )
	goto ERROR;
    if ( (y2 = U_BH) > SCR_Y )
	goto ERROR;
    sx = x2 - x1; sy = y2 - y1;
    if ( sx <= 0 || sy <= 0 )
	goto ERROR;
    sp = (x1 * 2 + (MAX_X * 2) * y1);

    if ( (cx = U_CX) == 0 || cx > sy )
	cx = sy;
    for ( ; cx > 0 ; cx-- ) {
	switch(U_AL) {
	    case 1:	/*  */
		vp = sp + (MAX_X * 2) * (sy - 1);
		for ( i = 0 ; i < (sy-1) ; i++ ) {
		    vramcpy(vp,vp - (MAX_X * 2),sx * 2);
		    vp -= (MAX_X * 2);
		}
		colset(sp,DEFCOL,sx * 2);
		break;
	    case 2:	/* E */
		vp = sp + (sx * 2) - 2;
		for ( i = 0 ; i < sy ; i++ ) {
		    vramrcpy(vp,vp - 2,sx * 2 - 2);
		    vp += (MAX_X * 2);
		}
		vp = sp;
		for ( i = 0 ; i < sy ; i++ ) {
		    colset(vp,DEFCOL,2);
		    vp += (MAX_X * 2);
		}
		break;
	    case 3:	/*  */
		vp = sp;
		for ( i = 0 ; i < sy ; i++ ) {
		    vramcpy(vp,vp + 2,sx * 2 - 2);
		    vp += (MAX_X * 2);
		}
		vp = sp + (sx * 2) - 2;
		for ( i = 0 ; i < sy ; i++ ) {
		    colset(vp,DEFCOL,2);
		    vp += (MAX_X * 2);
		}
		break;
            default: 	/* case 0  */
		for ( vp = sp,i = 0 ; i < (sy-1) ; i++ ) {
		    vramcpy(vp,vp + (MAX_X * 2),sx * 2);
		    vp += (MAX_X * 2);
		}
		colset(vp,DEFCOL,sx * 2);
		break;
	}
    }
    return;
ERROR:
    U_AH = 0x02;
    U_CF |= 0x0001;
}
void	VDB_1B(reg)	/* R\|@\̐ݒ */
register struct _REGSET far *reg;
{
    int     i;

    i = Con_mode;
    Con_mode = (U_AL & 0xC7) | 0x08;
    if ( (i & 0x40) != (Con_mode & 0x40) ) {
	if ( (Con_mode & 0x40) != 0 )
	    SCR_Y--;
	else
	    SCR_Y++;
    }
}
void	VDB_1C(reg)	/* R\|@\̓ǂݎ */
register struct _REGSET far *reg;
{
    U_AL = Con_mode;
}
void	VDB_1D(reg)	/* ̏o */
register struct _REGSET far *reg;
{
    Chr_out(U_AL);
}
void	VDB_1E(reg)	/* ̏o */
register struct _REGSET far *reg;
{
    int     i;
    UCHAR far *p;

    SEGSET(p,U_DS);
    OFFSET(p,U_DI);
    for ( i = U_CX ; i > 0 ; i-- )
	Chr_out(*(p++));
}
void	VDB_1F(reg)	/* VXes */
register struct _REGSET far *reg;
{
    int    ch,cx,at,md;
    UNSIG far *p;
    UCHAR far *cp;
    UCHAR far *ap;
    UCHAR far *vp;

    if ( (Con_mode & 0x40) == 0 )
	return;

    OFFSET(p,U_DI);
    SEGSET(p,U_DS);

    OFFSET(cp,*(p++));
    SEGSET(cp,*(p++));

    OFFSET(ap,*(p++));
    SEGSET(ap,*(p++));

    OFFSET(vp,((U_DL & 0x7F) - 1) * 2 + (MAX_X * 2) * SCR_Y);
    SEGSET(vp,CVRAM);

    cx = U_CX;
    for ( ; cx > 0 ; cx-- ) {
	*(vp++) = *(cp++);
	if ( U_AL != 1 ) {
	    at = DEFCOL;
	    md = *(ap++);
	} else {
	    md = *(ap++);
	    at = *(ap++) & 0x38;
	    at |= (*(ap++) & 0x07); ap++;
	}
	*(vp++) = at;
	if ( md == 0x03 ) {
	    ch = (*(vp-4) << 8) | *(vp-2);
	    *(vp-4) = *(vp-2) = DMYKAN;
	    *(vp-3) |= 0x40;
	    SEGSET(vp,KVRAM);
	    *(vp-4) = ch >> 8;
	    *(vp-3) = ch;
	    SEGSET(vp,CVRAM);
	}
    }
}
void	VDB_20(reg)	/* wiF̓ǂݎ */
register struct _REGSET far *reg;
{
    U_DX = BAKCOL;
}
void	BIOS_91(reg)
register struct _REGSET far *reg;
{
    int     cmd;
    static void (*VDB_table[])()={
	VDB_00,	VDB_01,	VDB_02,	VDB_03,	VDB_04,	VDB_05,	VDB_06,	VDB_07,
	VDB_08,	VDB_09,	VDB_0A,	VDB_0B,	VDB_0C,	VDB_0D,	VDB_0E,	VDB_0F,
	VDB_10,	VDB_11,	VDB_12,	VDB_13,	VDB_14,	VDB_15,	VDB_16,	VDB_17,
	VDB_18,	VDB_19,	VDB_1A,	VDB_1B,	VDB_1C,	VDB_1D,	VDB_1E,	VDB_1F,
	VDB_20 };

/*    Act_Dsp = TRUE;	*/
    if ( (cmd = U_AH) <= 0x20 ) {
	U_AH = 0;
	U_CF &= 0xFFFE;
	(*VDB_table[cmd])(reg);
    } else {
    	U_AH = 0x01;
    	U_CF |= 0x0001;
    }
/*    Act_Dsp = FALSE; */
}
